<?php
/*
 * UnifonicAuthenticateLib
 *
 * This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
 */

namespace UnifonicAuthenticateLib\Models;

use JsonSerializable;

/**
 * @todo Write general description for this model
 */
class Verification implements JsonSerializable
{
    /**
     * Address of receiver
     * @required
     * @var string $to public property
     */
    public $to;

    /**
     * Status of Verification request. It could be `pending`, `sent`, `failed`, `verified`
     * @var string $status public property
     */
    public $status;

    /**
     * Length of the verification code
     * @var integer|null $length public property
     */
    public $length;

    /**
     * Channel that will be used to send verification code. If this channel fails to send verification code.
     * System will use the next highest priority configured channel. Possible values are `sms`, `voice` ,
     * `whatsapp`.
     * @required
     * @var string $channel public property
     */
    public $channel;

    /**
     * In what language you want to send `en`, `ar`
     * @var string|null $locale public property
     */
    public $locale;

    /**
     * The type of code to be generated. `numeric`
     * @maps code_type
     * @var string|null $codeType public property
     */
    public $codeType;

    /**
     * Unique if of verification
     * @var string $id public property
     */
    public $id;

    /**
     * Response type in case of check. It could be `correct` and `incorrect` based on the given `code`
     * @maps response_status
     * @var string $responseStatus public property
     */
    public $responseStatus;

    /**
     * Constructor to set initial or default values of member properties
     * @param string  $to             Initialization value for $this->to
     * @param string  $status         Initialization value for $this->status
     * @param integer $length         Initialization value for $this->length
     * @param string  $channel        Initialization value for $this->channel
     * @param string  $locale         Initialization value for $this->locale
     * @param string  $codeType       Initialization value for $this->codeType
     * @param string  $id             Initialization value for $this->id
     * @param string  $responseStatus Initialization value for $this->responseStatus
     */
    public function __construct()
    {
        if (8 == func_num_args()) {
            $this->to             = func_get_arg(0);
            $this->status         = func_get_arg(1);
            $this->length         = func_get_arg(2);
            $this->channel        = func_get_arg(3);
            $this->locale         = func_get_arg(4);
            $this->codeType       = func_get_arg(5);
            $this->id             = func_get_arg(6);
            $this->responseStatus = func_get_arg(7);
        }
    }


    /**
     * Encode this object to JSON
     */
    public function jsonSerialize()
    {
        $json = array();
        $json['to']              = $this->to;
        $json['status']          = $this->status;
        $json['length']          = $this->length;
        $json['channel']         = $this->channel;
        $json['locale']          = $this->locale;
        $json['code_type']       = $this->codeType;
        $json['id']              = $this->id;
        $json['response_status'] = $this->responseStatus;

        return $json;
    }
}
